<?PHP
	define("THUMBDIR", "/tmp/.thumbnails");
	define("BASEDIR", "/var/www/html/bildarkiv");
	define("IMG_QUALITY", 80);

	function myscandir($path)
	{
		if($dh = @opendir($path))
		{
			$n = 0;
			while(($item = readdir($dh)) !== false)
			{
				if($item != "." && $item != "..")
					$contents[$n++] = $item;
			}
		}
		return $contents;
	}

	function create_from_dir($source, $destination, $ysize, $stamp1, $stamp2)
	{
		$files = myscandir($source);
		foreach($files as $file)
		{
			if($file != $GLOBALS[THUMB_DIR])
			{
				$dest_file = $destination."/".$file;
				create_new_image($source."/".$file, $dest_file, $ysize, $stamp1, $stamp2);
				chmod($dest_file, 0666);
			}
		}
	}

	function create_new_image($source, $output, $thumb_y, $stamp1, $stamp2)
	{
		global $IMG_QUALITY;
		$img_properties = GetImageSize($source);
		if(!$img_properties[2] == 2)
			return(0);
		else
		{
			$src_img = imagecreatefromjpeg($source);
			$src_x = $img_properties[0];
			$src_y = $img_properties[1];

			//ensures that the image about to be created has a positive size but not a huge one
			if($thumb_y <= 0 || $thumb_y > 1500)
				return(0);

			$scale = $thumb_y/$src_y;
			$thumb_x = (int)(round($src_x * $scale));
			$thumb_y = (int)($thumb_y);
			$dest_img = imagecreatetruecolor($thumb_x, $thumb_y);

			// try to resize and copy the source image into the thumbnail image
			if(!imagecopyresized($dest_img, $src_img, 0, 0, 0, 0, $thumb_x, $thumb_y, $src_x, $src_y))
			{
				imagedestroy($src_img);
				imagedestroy($dest_img);
				return(0);
			}
			else
			{
				imagedestroy($src_img);

				if($stamp1 != "")
				{
					$textcolor = imagecolorallocate($dest_img, 255, 255, 255);
					imagestring($dest_img, 5, 10, 5, $stamp1, $textcolor);
				}

				if($stamp2 != "")
				{
					$textcolor = imagecolorallocate($dest_img, 255, 255, 255);
					imagestring($dest_img, 5, 10, 20, $stamp2, $textcolor);
				}

				// try to actually generate the thumbnail image file
				if(imagejpeg($dest_img, $output, $IMG_QUALITY))
				{
					imagedestroy($dest_img);
					return(1);
				}
			}
			imagedestroy($dest_img);
			return(0);
		}
	}
PHP?>
